"""
    Criteo API

    Criteo API - RetailMedia  # noqa: E501

    The version of the OpenAPI document: Preview
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from criteo_api_retailmedia_preview.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from criteo_api_retailmedia_preview.exceptions import ApiAttributeError



class AsyncOffsiteReport(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('dimensions',): {
            'DATE': "date",
            'HOUR': "hour",
            'DAYSDIFFERENCE': "daysDifference",
            'ADVDATE': "advDate",
            'ADVHOUR': "advHour",
            'CAMPAIGNID': "campaignId",
            'CAMPAIGNNAME': "campaignName",
            'LINEITEMID': "lineItemId",
            'LINEITEMNAME': "lineItemName",
            'RETAILERID': "retailerId",
            'RETAILERNAME': "retailerName",
            'BILLINGTYPE': "billingType",
            'ENVIRONMENT': "environment",
            'ADFORMATSIZE': "adFormatSize",
            'SSP': "ssp",
            'PUBLISHER': "publisher",
            'INVENTORYTYPE': "inventoryType",
            'MEDIATYPE': "mediaType",
            'BUYTYPE': "buyType",
            'SALESCHANNEL': "salesChannel",
            'CREATIVEID': "creativeId",
            'CREATIVENAME': "creativeName",
        },
        ('metrics',): {
            'AUDIENCE': "audience",
            'UNIQUEUSERS': "uniqueUsers",
            'REACHRATE': "reachRate",
            'IMPRESSIONS': "impressions",
            'FREQUENCY': "frequency",
            'WINRATE': "winRate",
            'CLICKS': "clicks",
            'CTR': "ctr",
            'VIEWABILITY': "viewability",
            'CPC': "cpc",
            'ECPM': "ecpm",
            'CPM': "cpm",
            'SPEND': "spend",
            'UNITS': "units",
            'SALES': "sales",
            'ROAS': "roas",
            'VIDEOSTARTS': "videoStarts",
            'VIDEOSPLAYEDTO25': "videosPlayedTo25",
            'VIDEOSPLAYEDTO50': "videosPlayedTo50",
            'VIDEOSPLAYEDTO75': "videosPlayedTo75",
            'VIDEOSPLAYEDTO100': "videosPlayedTo100",
            'VIDEOSTARTINGRATE': "videoStartingRate",
            'VIDEOCOMPLETIONRATE': "videoCompletionRate",
            'VIDEOCPC': "videoCPC",
            'VIDEOCPCV': "videoCPCV",
            'VISITS': "visits",
            'QUALIFIEDVISITS': "qualifiedVisits",
            'LANDINGRATE': "landingRate",
        },
        ('buy_type',): {
            'AUCTION': "auction",
            'PREFERREDDEALS': "preferredDeals",
            'SPONSORSHIP': "sponsorship",
        },
        ('campaign_type',): {
            'ALL': "all",
            'SPONSOREDPRODUCTS': "sponsoredProducts",
            'ONSITEDISPLAYS': "onSiteDisplays",
        },
        ('click_attribution_window',): {
            'NONE': "none",
            '7D': "7D",
            '14D': "14D",
            '30D': "30D",
        },
        ('format',): {
            'JSON': "json",
            'JSON-COMPACT': "json-compact",
            'JSON-NEWLINE': "json-newline",
            'CSV': "csv",
        },
        ('media_type',): {
            'UNKNOWN': "unknown",
            'VIDEO': "video",
            'DISPLAY': "display",
            'ALL': "all",
        },
        ('sales_channel',): {
            'ONLINE': "online",
            'OFFLINE': "offline",
            'ALL': "all",
        },
        ('view_attribution_window',): {
            'NONE': "none",
            '1D': "1D",
            '7D': "7D",
            '14D': "14D",
            '30D': "30D",
        },
    }

    validations = {
        ('dimensions',): {
            'min_items': 1,
        },
        ('metrics',): {
            'min_items': 1,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'account_ids': ([str],),  # noqa: E501
            'dimensions': ([str],),  # noqa: E501
            'end_date': (datetime,),  # noqa: E501
            'metrics': ([str],),  # noqa: E501
            'start_date': (datetime,),  # noqa: E501
            'buy_type': (str,),  # noqa: E501
            'campaign_ids': ([str],),  # noqa: E501
            'campaign_type': (str,),  # noqa: E501
            'click_attribution_window': (str,),  # noqa: E501
            'creative_ids': ([str],),  # noqa: E501
            'format': (str,),  # noqa: E501
            'line_item_ids': ([str],),  # noqa: E501
            'media_type': (str,),  # noqa: E501
            'retailer_ids': ([str],),  # noqa: E501
            'sales_channel': (str,),  # noqa: E501
            'timezone': (str,),  # noqa: E501
            'view_attribution_window': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'account_ids': 'accountIds',  # noqa: E501
        'dimensions': 'dimensions',  # noqa: E501
        'end_date': 'endDate',  # noqa: E501
        'metrics': 'metrics',  # noqa: E501
        'start_date': 'startDate',  # noqa: E501
        'buy_type': 'buyType',  # noqa: E501
        'campaign_ids': 'campaignIds',  # noqa: E501
        'campaign_type': 'campaignType',  # noqa: E501
        'click_attribution_window': 'clickAttributionWindow',  # noqa: E501
        'creative_ids': 'creativeIds',  # noqa: E501
        'format': 'format',  # noqa: E501
        'line_item_ids': 'lineItemIds',  # noqa: E501
        'media_type': 'mediaType',  # noqa: E501
        'retailer_ids': 'retailerIds',  # noqa: E501
        'sales_channel': 'salesChannel',  # noqa: E501
        'timezone': 'timezone',  # noqa: E501
        'view_attribution_window': 'viewAttributionWindow',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, account_ids, dimensions, end_date, metrics, start_date, *args, **kwargs):  # noqa: E501
        """AsyncOffsiteReport - a model defined in OpenAPI

        Args:
            account_ids ([str]): Account ids to report on
            dimensions ([str]): List of dimensions to report on
            end_date (datetime): End date
            metrics ([str]): List of metrics to report on
            start_date (datetime): Start date

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            buy_type (str): Filter on buy type: Auction, Preferred Deals or Sponsorship. [optional]  # noqa: E501
            campaign_ids ([str]): Campaign ids to filter. [optional]  # noqa: E501
            campaign_type (str): Filter the type of campaigns to report on: sponsoredProducts or onSiteDisplays. [optional] if omitted the server will use the default value of "all"  # noqa: E501
            click_attribution_window (str): Click attribution window. [optional] if omitted the server will use the default value of "none"  # noqa: E501
            creative_ids ([str]): Creative ids to filter. [optional]  # noqa: E501
            format (str): Format of the output. [optional] if omitted the server will use the default value of "json-compact"  # noqa: E501
            line_item_ids ([str]): Line item ids to filter. [optional]  # noqa: E501
            media_type (str): Filter on the type of media: unknown, display, video. [optional] if omitted the server will use the default value of "all"  # noqa: E501
            retailer_ids ([str]): Retailer ids to filter. [optional]  # noqa: E501
            sales_channel (str): Filter on specific sales channel: offline or online. [optional] if omitted the server will use the default value of "all"  # noqa: E501
            timezone (str): Time zone : see criteo developer portal for supported time zones. [optional] if omitted the server will use the default value of "UTC"  # noqa: E501
            view_attribution_window (str): View attribution window. [optional] if omitted the server will use the default value of "none"  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.account_ids = account_ids
        self.dimensions = dimensions
        self.end_date = end_date
        self.metrics = metrics
        self.start_date = start_date
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, account_ids, dimensions, end_date, metrics, start_date, *args, **kwargs):  # noqa: E501
        """AsyncOffsiteReport - a model defined in OpenAPI

        Args:
            account_ids ([str]): Account ids to report on
            dimensions ([str]): List of dimensions to report on
            end_date (datetime): End date
            metrics ([str]): List of metrics to report on
            start_date (datetime): Start date

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            buy_type (str): Filter on buy type: Auction, Preferred Deals or Sponsorship. [optional]  # noqa: E501
            campaign_ids ([str]): Campaign ids to filter. [optional]  # noqa: E501
            campaign_type (str): Filter the type of campaigns to report on: sponsoredProducts or onSiteDisplays. [optional] if omitted the server will use the default value of "all"  # noqa: E501
            click_attribution_window (str): Click attribution window. [optional] if omitted the server will use the default value of "none"  # noqa: E501
            creative_ids ([str]): Creative ids to filter. [optional]  # noqa: E501
            format (str): Format of the output. [optional] if omitted the server will use the default value of "json-compact"  # noqa: E501
            line_item_ids ([str]): Line item ids to filter. [optional]  # noqa: E501
            media_type (str): Filter on the type of media: unknown, display, video. [optional] if omitted the server will use the default value of "all"  # noqa: E501
            retailer_ids ([str]): Retailer ids to filter. [optional]  # noqa: E501
            sales_channel (str): Filter on specific sales channel: offline or online. [optional] if omitted the server will use the default value of "all"  # noqa: E501
            timezone (str): Time zone : see criteo developer portal for supported time zones. [optional] if omitted the server will use the default value of "UTC"  # noqa: E501
            view_attribution_window (str): View attribution window. [optional] if omitted the server will use the default value of "none"  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.account_ids = account_ids
        self.dimensions = dimensions
        self.end_date = end_date
        self.metrics = metrics
        self.start_date = start_date
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
