"""
    Criteo API

    Criteo API - RetailMedia  # noqa: E501

    The version of the OpenAPI document: Preview
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from criteo_api_retailmedia_preview.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from criteo_api_retailmedia_preview.exceptions import ApiAttributeError



class SkuSlimDataPreview(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('global_brand_name',): {
            'max_length': 120,
            'min_length': 0,
        },
        ('category',): {
            'max_length': 1000,
            'min_length': 0,
        },
        ('name',): {
            'max_length': 1000,
            'min_length': 0,
        },
        ('retailer_brand_name',): {
            'max_length': 120,
            'min_length': 0,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'category_id': (str,),  # noqa: E501
            'global_brand_id': (str,),  # noqa: E501
            'global_brand_name': (str,),  # noqa: E501
            'is_in_stock': (bool,),  # noqa: E501
            'price': (float, none_type,),  # noqa: E501
            'updated_at': (datetime,),  # noqa: E501
            'category': (str,),  # noqa: E501
            'global_category_id': (str,),  # noqa: E501
            'gtin': (str, none_type,),  # noqa: E501
            'image_url': (str,),  # noqa: E501
            'mpn': (str, none_type,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'retailer_brand_id': (str,),  # noqa: E501
            'retailer_brand_name': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'category_id': 'categoryId',  # noqa: E501
        'global_brand_id': 'globalBrandId',  # noqa: E501
        'global_brand_name': 'globalBrandName',  # noqa: E501
        'is_in_stock': 'isInStock',  # noqa: E501
        'price': 'price',  # noqa: E501
        'updated_at': 'updatedAt',  # noqa: E501
        'category': 'category',  # noqa: E501
        'global_category_id': 'globalCategoryId',  # noqa: E501
        'gtin': 'gtin',  # noqa: E501
        'image_url': 'imageUrl',  # noqa: E501
        'mpn': 'mpn',  # noqa: E501
        'name': 'name',  # noqa: E501
        'retailer_brand_id': 'retailerBrandId',  # noqa: E501
        'retailer_brand_name': 'retailerBrandName',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, category_id, global_brand_id, global_brand_name, is_in_stock, price, updated_at, *args, **kwargs):  # noqa: E501
        """SkuSlimDataPreview - a model defined in OpenAPI

        Args:
            category_id (str): The category Id.
            global_brand_id (str): The global brand id associated to the product.
            global_brand_name (str): The name of the global brand.
            is_in_stock (bool): An indication of if the retailer currently has the product in stock.
            price (float, none_type): The price of the product on the retailer site. Can be omitted in certain circumstances
            updated_at (datetime): The last time this product was updated in the Retail Media Catalog. Represented as a UTC ISO8601 string.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            category (str): The full category breadcrumb in the retailers catalog.. [optional]  # noqa: E501
            global_category_id (str): The global category Id.. [optional]  # noqa: E501
            gtin (str, none_type): A GTIN identifier for the product if available. Covers variations such as EANs and UPCs.. [optional]  # noqa: E501
            image_url (str): An http image resource provided by the retailer.. [optional]  # noqa: E501
            mpn (str, none_type): The MPN for the product if available.. [optional]  # noqa: E501
            name (str): A short product name.. [optional]  # noqa: E501
            retailer_brand_id (str): The retailer brand id associated to the product.. [optional]  # noqa: E501
            retailer_brand_name (str): The name of the retailer brand.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.category_id = category_id
        self.global_brand_id = global_brand_id
        self.global_brand_name = global_brand_name
        self.is_in_stock = is_in_stock
        self.price = price
        self.updated_at = updated_at
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, category_id, global_brand_id, global_brand_name, is_in_stock, price, updated_at, *args, **kwargs):  # noqa: E501
        """SkuSlimDataPreview - a model defined in OpenAPI

        Args:
            category_id (str): The category Id.
            global_brand_id (str): The global brand id associated to the product.
            global_brand_name (str): The name of the global brand.
            is_in_stock (bool): An indication of if the retailer currently has the product in stock.
            price (float, none_type): The price of the product on the retailer site. Can be omitted in certain circumstances
            updated_at (datetime): The last time this product was updated in the Retail Media Catalog. Represented as a UTC ISO8601 string.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            category (str): The full category breadcrumb in the retailers catalog.. [optional]  # noqa: E501
            global_category_id (str): The global category Id.. [optional]  # noqa: E501
            gtin (str, none_type): A GTIN identifier for the product if available. Covers variations such as EANs and UPCs.. [optional]  # noqa: E501
            image_url (str): An http image resource provided by the retailer.. [optional]  # noqa: E501
            mpn (str, none_type): The MPN for the product if available.. [optional]  # noqa: E501
            name (str): A short product name.. [optional]  # noqa: E501
            retailer_brand_id (str): The retailer brand id associated to the product.. [optional]  # noqa: E501
            retailer_brand_name (str): The name of the retailer brand.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.category_id = category_id
        self.global_brand_id = global_brand_id
        self.global_brand_name = global_brand_name
        self.is_in_stock = is_in_stock
        self.price = price
        self.updated_at = updated_at
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
